/*
	Company:            Sensaura
	Copyright:          (C) 1998

	File Name:		    applicat.h
	File Description:	Header file for definition of Application class
	Author:			    Adam Philp
	Version:		    1.01.000
	Last Update:		01-DEC-98

	Target Compiler:	Microsoft Visual C++ Version 5.0
*/

#ifndef __applicat_h
#define __applicat_h

///////////////////////	Included files ////////////////////////////////////////////////////////////

#include "window.h"

///////////////////////	Class declarations ////////////////////////////////////////////////////////

/*
	Class:				Application
	Description:		Generic windows application class
*/

class Application 
{
public:									// Public constructor and destructor
	Application(LPCSTR, HINSTANCE, HINSTANCE, LPSTR, int);
	virtual ~Application();

public:									// Public member functions
	int				Run();
	HINSTANCE		GetInstance() const { return m_hInstance; }
	Window*			GetMainWindow() const { return m_hMainWindow; }

protected:								// Protected member functions
	virtual void	InitApplication();
	virtual void	InitInstance();
	virtual void	InitMainWindow();
	virtual int		MessageLoop();
	virtual bool	PreProcessMsg(MSG&);
	virtual bool	IdleAction(long idleCount);

private:								// Private member functions

public:									// Public data members

protected:								// Protected data members
	Window*			m_hMainWindow;
	HACCEL			m_hAccelTable;

private:								// Private data members
	int				m_nCmdShow;
	HINSTANCE		m_hInstance;
	HINSTANCE		m_hPrevInstance;
	LPCSTR			m_pName;
};

#endif
