/*
	Company:            Sensaura
	Copyright:          (C) 1998

	File Name:		    cd3drm.h
	File Description:	Header file for declaration of Direct3DRMObject class
	Author:			    Adam Philp
	File Version:	    1.01.000
	Last Update:		02-DEC-98

	Target Compiler:	Microsoft Visual C++ Version 5.0
*/

#ifndef __cd3drm_h						// Sentry, use file only if it's not already included
#define __cd3drm_h

///////////////////////	Included files ////////////////////////////////////////////////////////////

#include <d3drmwin.h>					// Direct3DRMWinDevice declaration 

///////////////////////	Class declarations ////////////////////////////////////////////////////////

/*
	Class:				Direct3DRMObject
	Description:		Supports an IDirect3DRM object rendered in a Window
*/

class Direct3DRMObject
{
public:									// Public constructor & destructor
	Direct3DRMObject(D3DVALUE);	
	virtual ~Direct3DRMObject();

public:									// Public member functions
	bool Create(HWND);
	void Release();
	bool Resize(int, int);

public:									// Public data members
	LPDIRECT3DRM2		m_pD3DRM;
    LPDIRECT3DRMDEVICE2	m_pDevice;     
    D3DRMCOLORMODEL		m_Model;        
    D3DRMRENDERQUALITY	m_Quality;
	LPDIRECT3DRMFRAME2	m_pScene;

	D3DVALUE			m_BackDistance;

private:								// Private member functions
	LPGUID FindDirect3DDevice();
	DWORD BitsPerPixelToDDBitDepth(int);

private:								// Private data members
	LPDIRECTDRAWCLIPPER	m_pDDClipper;
};

#endif									// End of sentry __cd3drm_h
