/*
	Company:            Sensaura
	Copyright:          (C) 1998

	File Name:		    dxwindow.h
	File Description:	Header file for definition of DirectXWindow class
	Author:			    Adam Philp
	Version:		    1.02.000
	Last Update:		14-JAN-99

	Target Compiler:	Microsoft Visual C++ Version 5.0
*/

#ifndef __dxwindow_h					// Sentry, use file only if it's not already included
#define __dxwindow_h

///////////////////////	Included files ////////////////////////////////////////////////////////////

#include "window.h"
#include "dxworld.h"

///////////////////////	Class declarations ////////////////////////////////////////////////////////

/*
	Class:				DirectXWindow
	Description:		Class combining standard Window support for our DirectXWorld class
*/

class DirectXWindow : public Window, private DirectXWorld
{
public:									// Public constructor & destructor
	DirectXWindow(Window*, LPCSTR, Application*);
	virtual ~DirectXWindow();

public:									// Public member functions
	virtual bool	Create();
	virtual LPSTR	GetClassName() const;
	virtual void	GetWindowClass(WNDCLASS&) const;

	virtual LRESULT EvCommand(UINT, HWND, UINT);
	virtual bool	IdleAction(long);

protected:								// Protected member functions
	virtual LRESULT WindowProc(UINT, WPARAM, LPARAM);
	virtual void	EvActivate(WORD, bool, HWND);
	virtual void	EvPaint();
	virtual void	EvSize(UINT, int, int);

private:								// Private member functions
	void EnableMainMenuItem(UINT, bool);
	void CheckMainMenuItem(UINT, bool);
	void UpdateMainMenu();
};

#endif									// End of sentry __dxwindow_h
