/*
	Company:            Sensaura
	Copyright:          (C) 1999

	Software Project:	Sensaura DirectSound3D Demo
	File Name:		    dxwldobj.h
	File Description:	Header file for definition of DirectXWorld 3D object classes
	Author:			    Adam Philp
	File Version:	    1.02.000
	Last Update:		11-FEB-99

	Target Compiler:	Microsoft Visual C++ Version 5.0
*/

#ifndef __dxwldobj_h					// Sentry, only use file if not already included
#define __dxwldobj_h

///////////////////////	Included files ////////////////////////////////////////////////////////////

#include "object3d.h"					// Declaration of 3D object base classes

///////////////////////	Constants /////////////////////////////////////////////////////////////////

const int ID_GLOBE				= 0x0100;
const int ID_SAUCER				= 0x0200;
const int ID_METEOR				= 0x0300;
const int ID_BULLET				= 0x0400;
const int ID_EXPLOSION			= 0x1000;

///////////////////////	DirectX world 3D object class declarations ////////////////////////////////

class D3DRMGlobeObject : public D3DRMSphereObject 
{
public:									// Public constructor & destructor
    D3DRMGlobeObject(DirectXWorld*, LPDIRECT3DRMMESHBUILDER2*, DWORD, DWORD);
    virtual ~D3DRMGlobeObject();

public:									// Public member functions

private:								// Private member functions
	bool SensauraWrap(LPDIRECT3DRMMESHBUILDER);

private:								// Private member variables
	LPDIRECT3DRMMESHBUILDER2* m_ppBuilder;
};

class D3DRMSaucerObject : public D3DRMBoxObject 
{
public:									// Public constructor & destructor
    D3DRMSaucerObject(DirectXWorld*, LPDIRECT3DRMMESHBUILDER, DWORD, DWORD);
    virtual ~D3DRMSaucerObject() {}

public:									// Public member functions
	virtual bool Update(D3DVALUE);

private:								// Private member variables
	D3DVALUE m_Velocity;
};

class D3DRMMeteorObject : public D3DRMBoxObject 
{
public:									// Public constructor & destructor
    D3DRMMeteorObject(DirectXWorld*, LPDIRECT3DRMMESHBUILDER, DWORD, DWORD);
    ~D3DRMMeteorObject() {}

public:									// Public member functions
	virtual bool Update(D3DVALUE);
};

class D3DRMBulletObject : public D3DRMSphereObject 
{
public:									// Public constructor & destructor
	D3DRMBulletObject(DirectXWorld*, LPDIRECT3DRMMESHBUILDER, DWORD, DWORD);
	~D3DRMBulletObject() {}
};

class D3DRMExplosionObject : public D3DRMBoxObject 
{
public:									// Public constructor & destructor
	D3DRMExplosionObject(DirectXWorld*, DWORD,		
						 LPDIRECT3DRMMESHBUILDER, LPD3DVECTOR,
						 DWORD,	DWORD);
	~D3DRMExplosionObject() {};

public:									// Public member functions
	virtual bool Update(D3DVALUE);

private:								// Private member variables
	D3DVALUE m_Red;
	D3DVALUE m_Green;
	D3DVALUE m_Blue;
};

typedef D3DRMGlobeObject*		LPD3DRMGLOBE;
typedef D3DRMSaucerObject*		LPD3DRMSAUCER;
typedef D3DRMMeteorObject*		LPD3DRMMETEOR;
typedef D3DRMBulletObject*		LPD3DRMBULLET;
typedef D3DRMExplosionObject*	LPD3DRMEXPLOSION;

#endif									// End of sentry
